// DeviceDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "CrystalMark.h"
#include "CrystalMarkDlg.h"
#include "DeviceDlg.h"
#include "../CrystalMarkShare/Share.h"

#include <iphlpapi.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDeviceDlg _CAO


CDeviceDlg::CDeviceDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDeviceDlg::IDD, pParent)
{
	SysInfo = ((CCrystalMarkDlg*)pParent)->SysInfo;
	//{{AFX_DATA_INIT(CDeviceDlg)
	m_DeviceChipSet = _T("");
	m_DeviceIDE = _T("");
	m_DeviceNorth = _T("");
	m_DeviceSouth = _T("");
	m_DeviceVideo = _T("");
	m_DeviceVideoChip = _T("");
	m_DeviceVideoVendor = _T("");
	m_DeviceVideoRAM = _T("");
	m_DeviceVideoCaption = _T("");
	m_DeviceVideoDriverDate = _T("");
	m_DeviceVideoDriverVersion = _T("");
	m_DeviceDirectXVersion = _T("");
	m_DeviceDisplayMode = _T("");
	m_DeviceFont = _T("");
	m_DeviceFontSmoothing = _T("");
	m_NetMacAddress = _T("");
	m_NetIpAddress = _T("");
	m_NetDnsServer = _T("");
	m_NetDhcpServer = _T("");
	m_NetDefaultGateway = _T("");
	m_NetAdapterName = _T("");
	m_NetSubnetMask = _T("");
	//}}AFX_DATA_INIT
}


void CDeviceDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDeviceDlg)
	DDX_Control(pDX, IDC_NETWORK_DHCP_SERVER, m_NetDhcpServerC);
	DDX_Control(pDX, IDC_NETWORK_ADAPTER_NAME, m_NetAdapterNameC);
	DDX_Control(pDX, IDC_NETWORK_DEFAULT_GATEWAY, m_NetDefaultGatewayC);
	DDX_Control(pDX, IDC_NETWORK_DNS_SERVER, m_NetDnsServerC);
	DDX_Control(pDX, IDC_NETWORK_IP_ADDRESS, m_NetIpAddressC);
	DDX_Control(pDX, IDC_NETWORK_MAC_ADDRESS, m_NetMacAddressC);
	DDX_Control(pDX, IDC_NETWORK_SUBNET_MASK, m_NetSubnetMaskC);
	DDX_Control(pDX, IDC_DEVICE_NETWORK_LIST, m_DeviceNetworkList);
	DDX_Text(pDX, IDC_DEVICE_CHIP_SET, m_DeviceChipSet);
	DDX_Text(pDX, IDC_DEVICE_IDE, m_DeviceIDE);
	DDX_Text(pDX, IDC_DEVICE_NORTH, m_DeviceNorth);
	DDX_Text(pDX, IDC_DEVICE_SOUTH, m_DeviceSouth);
	DDX_Text(pDX, IDC_DEVICE_VIDEO, m_DeviceVideo);
	DDX_Text(pDX, IDC_DEVICE_VIDEO_CHIP, m_DeviceVideoChip);
	DDX_Text(pDX, IDC_DEVICE_VIDEO_VENDOR, m_DeviceVideoVendor);
	DDX_Text(pDX, IDC_DEVICE_VIDEO_RAM, m_DeviceVideoRAM);
	DDX_Text(pDX, IDC_DEVICE_VIDEO_CAPTION, m_DeviceVideoCaption);
	DDX_Text(pDX, IDC_DEVICE_VIDEO_DRIVER_DATE, m_DeviceVideoDriverDate);
	DDX_Text(pDX, IDC_DEVICE_VIDEO_DRIVER_VERSION, m_DeviceVideoDriverVersion);
	DDX_Text(pDX, IDC_DEVICE_DIRECT_X_VERSION, m_DeviceDirectXVersion);
	DDX_Text(pDX, IDC_DEVICE_DISPLAY_MODE, m_DeviceDisplayMode);
	DDX_Text(pDX, IDC_DEVICE_FONT_SMOOTHING, m_DeviceFontSmoothing);
	DDX_Text(pDX, IDC_NETWORK_MAC_ADDRESS, m_NetMacAddress);
	DDX_Text(pDX, IDC_NETWORK_IP_ADDRESS, m_NetIpAddress);
	DDX_Text(pDX, IDC_NETWORK_DNS_SERVER, m_NetDnsServer);
	DDX_Text(pDX, IDC_NETWORK_DHCP_SERVER, m_NetDhcpServer);
	DDX_Text(pDX, IDC_NETWORK_DEFAULT_GATEWAY, m_NetDefaultGateway);
	DDX_Text(pDX, IDC_NETWORK_ADAPTER_NAME, m_NetAdapterName);
	DDX_Text(pDX, IDC_NETWORK_SUBNET_MASK, m_NetSubnetMask);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDeviceDlg, CDialog)
	//{{AFX_MSG_MAP(CDeviceDlg)
	ON_WM_CTLCOLOR()
	ON_MESSAGE(WM_DISPLAYCHANGE,OnDisplayChange)
	ON_NOTIFY(NM_CLICK, IDC_DEVICE_NETWORK_LIST, OnClickDeviceNetworkList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDeviceDlg bZ[W nh

//typedef HRESULT(WINAPI * DIRECTDRAWCREATE)( GUID*, LPDIRECTDRAW*, IUnknown* );
typedef DWORD(WINAPI * GETIFTABLE)(PMIB_IFTABLE,PULONG,BOOL);
typedef DWORD(WINAPI * GETADAPTERSINFO)(IP_ADAPTER_INFO*,unsigned long*);

BOOL CDeviceDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	char str[1024];
	CString cstr;
	DWORD data;

	SysInfo->GetString(PCI_CHIP_SET_NAME_SI,str);	m_DeviceChipSet = " ";	m_DeviceChipSet += str;
	SysInfo->GetString(PCI_NORTH_DEVICE_NAME,str);	m_DeviceNorth = " ";	m_DeviceNorth += str;
	SysInfo->GetString(PCI_SOUTH_DEVICE_NAME,str);	m_DeviceSouth = " ";	m_DeviceSouth += str;
	SysInfo->GetString(PCI_VIDEO_DEVICE_NAME,str);	m_DeviceVideo = " ";	m_DeviceVideo += str;

	SysInfo->GetData(PCI_NORTH_VENDOR_ID,&data);
	m_DeviceNorthVID.Format("%d",data);
	SysInfo->GetData(PCI_NORTH_DEVICE_ID,&data);
	m_DeviceNorthDID.Format("%d",data);
	SysInfo->GetData(PCI_NORTH_REVISION_ID,&data);
	m_DeviceNorthRID.Format("%d",data);

	SysInfo->GetData(PCI_SOUTH_VENDOR_ID,&data);
	m_DeviceSouthVID.Format("%d",data);
	SysInfo->GetData(PCI_SOUTH_DEVICE_ID,&data);
	m_DeviceSouthDID.Format("%d",data);
	SysInfo->GetData(PCI_SOUTH_REVISION_ID,&data);
	m_DeviceSouthRID.Format("%d",data);

	SysInfo->GetData(PCI_VIDEO_VENDOR_ID,&data);
	m_DeviceVideoVID.Format("%d",data);
	SysInfo->GetData(PCI_VIDEO_DEVICE_ID,&data);
	m_DeviceVideoDID.Format("%d",data);
	SysInfo->GetData(PCI_VIDEO_REVISION_ID,&data);
	m_DeviceVideoRID.Format("%d",data);

/*
	DWORD data;
	SysInfo->GetString(WMI_IDE_CAPTION_BASE,str);		m_DeviceIDE = str;
	SysInfo->GetString(WMI_VIDEO_CAPTION_BASE,str);		m_DeviceVideoCaption = str;
	SysInfo->GetString(WMI_VIDEO_PROCESSOR_BASE,str);	m_DeviceVideoChip = str;
	SysInfo->GetString(WMI_VIDEO_VENDOR_BASE,str);		m_DeviceVideoVendor = str;
	SysInfo->GetData(WMI_VIDEO_RAM_BASE,&data);		if(data != 0xFFFFFFFF){wsprintf(str,"%d MB",data);m_DeviceVideoRAM = str;}
	SysInfo->GetString(WMI_VIDEO_DRIVER_VERSION_BASE,str);	m_DeviceVideoDriverVersion = str;
	SysInfo->GetString(WMI_VIDEO_DRIVER_DATE_BASE,str);		m_DeviceVideoDriverDate = str;
*/
	GetDirectXVersion();
	GetFontStatus(m_DeviceFontSmoothing);
	GetDisplayMode();

// Xgr[̍\z
	LVCOLUMN myColumn;
	myColumn.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_ORDER ;
	// Rg[̕擾
	CRect cr;m_DeviceNetworkList.GetClientRect(cr);
	DWORD width = cr.Width() - GetSystemMetrics(SM_CXVSCROLL);

	double comctl32 = GetFileVersion("comctl32.dll");
	if( comctl32 >= 4.70 ){
		long dwStyle = ListView_GetExtendedListViewStyle(m_DeviceNetworkList.m_hWnd);
		dwStyle |=	LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES;
		ListView_SetExtendedListViewStyle(m_DeviceNetworkList.m_hWnd, dwStyle);
	}
	if( comctl32 >= 4.71 ){
		m_DeviceNetworkList.GetHeaderCtrl()->EnableWindow(FALSE);
	}

	m_DeviceNetworkList.InsertColumn(0,"Type",LVCFMT_CENTER,width * 4 / 30,0);
	m_DeviceNetworkList.InsertColumn(1,"Adapter Name",LVCFMT_LEFT,width * 26 / 30,0);
	m_DeviceNetworkList.InsertColumn(2,"MAC Address",LVCFMT_CENTER,0,0);
	m_DeviceNetworkList.InsertColumn(3,"IP Address",LVCFMT_CENTER,0,0);
	m_DeviceNetworkList.InsertColumn(4,"Subnet Mask",LVCFMT_CENTER,0,0);
	m_DeviceNetworkList.InsertColumn(5,"Default Gateway",LVCFMT_CENTER,0,0);
	m_DeviceNetworkList.InsertColumn(6,"DHCP Server",LVCFMT_CENTER,0,0);
//	m_DeviceNetworkList.InsertColumn(7,"DNS Server",LVCFMT_CENTER,0,0);

	LVITEM myItem;
	memset(&myItem,0,sizeof(LVITEM));
	myItem.mask = LVIF_TEXT;

	UpdateData(FALSE);

	GETIFTABLE GetIfTable = NULL;
	GETADAPTERSINFO GetAdaptersInfo = NULL;
	HINSTANCE hDLL = LoadLibrary( "iphlpapi.dll" );
	if(  hDLL != NULL ){
		GetIfTable = (GETIFTABLE)GetProcAddress( hDLL, "GetIfTable" );
		GetAdaptersInfo = (GETADAPTERSINFO)GetProcAddress( hDLL, "GetAdaptersInfo" );
	}else{
		return FALSE;
	}

	if(GetIfTable != NULL){
		DWORD d = 0;
		//C^tF[X̎擾
		GetIfTable(NULL,&d,FALSE);
		//l擾
		PMIB_IFTABLE table = (PMIB_IFTABLE)new char[d];
		PIP_ADAPTER_INFO pai = NULL;
		DWORD dwSize = 0;
		// Get size of buffer needed:
		GetAdaptersInfo(NULL, &dwSize);
		pai = (PIP_ADAPTER_INFO)GlobalAlloc(GPTR, dwSize);
		GetAdaptersInfo(pai, &dwSize);

		if(GetIfTable((PMIB_IFTABLE)table,&d,FALSE)==NO_ERROR ){
			for(int i=0;i< (int)table->dwNumEntries;i++ ){

				if(table->table[i].dwType == MIB_IF_TYPE_ETHERNET){cstr = "Ethernet";}
				else if(table->table[i].dwType == MIB_IF_TYPE_TOKENRING){cstr = "Token Ring";}
				else if(table->table[i].dwType == MIB_IF_TYPE_FDDI){cstr = "FDDI";}
				else if(table->table[i].dwType == MIB_IF_TYPE_PPP){cstr = "PPP";}
				else if(table->table[i].dwType == MIB_IF_TYPE_SLIP){cstr = "SLIP";}
				else if(table->table[i].dwType == MIB_IF_TYPE_LOOPBACK){cstr = "Loopback";continue;}
				else {cstr = "Other";continue;}
				m_DeviceNetworkList.InsertItem(i,cstr);

				// Description
				cstr.Format("%s",(int)table->table[i].bDescr);
				m_DeviceNetworkList.SetItemText(i,1,cstr);

				// MAC ADDRESS
				cstr.Format("%02X:%02X:%02X:%02X:%02X:%02X",
					table->table[i].bPhysAddr[0],
					table->table[i].bPhysAddr[1],
					table->table[i].bPhysAddr[2],
					table->table[i].bPhysAddr[3],
					table->table[i].bPhysAddr[4],
					table->table[i].bPhysAddr[5]);
				m_DeviceNetworkList.SetItemText(i,2,cstr);

				// IP ADDRESS
				cstr.Format("%s",(&pai[i])->IpAddressList.IpAddress.String);
				m_DeviceNetworkList.SetItemText(i,3,cstr);

				// Subnet Mask
				cstr.Format("%s",(&pai[i])->IpAddressList.IpMask.String);
				m_DeviceNetworkList.SetItemText(i,4,cstr);

				// Default Gateway
				cstr.Format("%s",(&pai[i])->GatewayList.IpAddress.String);
				m_DeviceNetworkList.SetItemText(i,5,cstr);

				// DHCP Server
				cstr.Format("%s",(&pai[i])->DhcpServer.IpAddress.String);
				m_DeviceNetworkList.SetItemText(i,6,cstr);

				// DNS Server
				// cstr.Format("%s",(&pai[i])->DhcpServer);
				// m_DeviceNetworkList.SetItemText(i,5,cstr);
			}
			SetNetworkInfo(0);
		}
		delete [] table;
		GlobalFree(pai);
	}

	FreeLibrary(hDLL);
	UpdateData(FALSE);
	
	return TRUE;
}

void CDeviceDlg::SetNetworkInfo(int hotItem)
{
	CString cstr;
	cstr.Format("%d",hotItem);
	if(0 <= hotItem && hotItem < m_DeviceNetworkList.GetItemCount() ){
		m_NetAdapterName = m_DeviceNetworkList.GetItemText(hotItem,1);
		m_NetMacAddress = m_DeviceNetworkList.GetItemText(hotItem,2);
		m_NetIpAddress = m_DeviceNetworkList.GetItemText(hotItem,3);
		m_NetSubnetMask = m_DeviceNetworkList.GetItemText(hotItem,4);
		m_NetDefaultGateway = m_DeviceNetworkList.GetItemText(hotItem,5);
		m_NetDhcpServer = m_DeviceNetworkList.GetItemText(hotItem,6);

		UpdateData(FALSE);

		if( gFlagBack ){
			WindowFlash(m_NetAdapterNameC);
			WindowFlash(m_NetMacAddressC);
			WindowFlash(m_NetIpAddressC);
			WindowFlash(m_NetSubnetMaskC);
			WindowFlash(m_NetDefaultGatewayC);
			WindowFlash(m_NetDhcpServerC);
//			WindowFlash();
		}
	}

}

void CDeviceDlg::GetDirectXVersion()
{
	char str[256];
	SysInfo->GetString(WIN_DIRECT_X_VERSION,str);

	if(atof(str) > 0.0){
		m_DeviceDirectXVersion.Format("%s",str);
	}else{
		m_DeviceDirectXVersion = "Not installed";
	}
}

void CDeviceDlg::GetDisplayMode()
{
	CDC	*dcDisplay;
	dcDisplay = GetDC();
	if( GetDeviceCaps(dcDisplay->m_hDC,VREFRESH) > 1 ){
		m_DeviceDisplayMode.Format(
			"%d x %d %dbit %dHz",
			GetDeviceCaps(dcDisplay->m_hDC,HORZRES),
			GetDeviceCaps(dcDisplay->m_hDC,VERTRES),
			GetDeviceCaps(dcDisplay->m_hDC,BITSPIXEL),
			GetDeviceCaps(dcDisplay->m_hDC,VREFRESH));
	}else{
		m_DeviceDisplayMode.Format(
			"%d x %d %dbit",
			GetDeviceCaps(dcDisplay->m_hDC,HORZRES),
			GetDeviceCaps(dcDisplay->m_hDC,VERTRES),
			GetDeviceCaps(dcDisplay->m_hDC,BITSPIXEL));
	}
	ReleaseDC(dcDisplay);
}

LONG CDeviceDlg::OnDisplayChange(UINT wParam, LONG lParam)
{
 	GetDisplayMode();
	UpdateData(FALSE);
	return 0;
}


HBRUSH CDeviceDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if( gFlagBack ){
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
				return (HBRUSH)GetStockObject(HOLLOW_BRUSH);
			}
			case CTLCOLOR_DLG:
			{
				return (HBRUSH)gBackBrush;
			}
		}
	}else{
		switch (nCtlColor)
		{
			case CTLCOLOR_STATIC:
			{
				pDC->SetTextColor(gTextColor);
				pDC->SetBkMode(TRANSPARENT);
			}
		}
	}

	return hbr;
}

void CDeviceDlg::OnClickDeviceNetworkList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	//NbNW擾
	DWORD dwPos = ::GetMessagePos();
	CPoint point ((int)LOWORD(dwPos),(int)HIWORD(dwPos));
	m_DeviceNetworkList.ScreenToClient(&point);

	SetNetworkInfo( m_DeviceNetworkList.HitTest(point) );
	
	*pResult = 0;
}
