#include "stdafx.h"
#include "Mark.h"
#include "resource.h"

#pragma comment(lib,"msimg32.lib")

extern volatile int FlagLoop;

void GDITextThread(void *thread)
{
	_ThreadStruct* ThreadStruct = (_ThreadStruct *)thread;
	_GDIInput* GDIInput = (_GDIInput*)(ThreadStruct->ExData);
	DWORD count = 0;
	CString cstr("CrystalMark");

	CFont myFont;
	if(GDIInput->Option == 1){
		myFont.CreatePointFont(120,"lr oSVbN",NULL);
		CFont* oldFont = GDIInput->dcGDI->SelectObject(&myFont);
		for(;FlagLoop;){
			GDIInput->dcGDI->SetTextColor(RGB(rand()%256,rand()%256,rand()%256));
			GDIInput->dcGDI->TextOut(rand()% GDIInput->Width,rand() % GDIInput->Height,cstr);
			count++;
		}
		GDIInput->dcGDI->SelectObject(oldFont);
	}else if(GDIInput->Option == 2){
		GDIInput->dcGDI->SetBkMode(TRANSPARENT);
		myFont.CreatePointFont(120,"lr oSVbN",NULL);
		CFont* oldFont = GDIInput->dcGDI->SelectObject(&myFont);
		for(;FlagLoop;){
			GDIInput->dcGDI->SetTextColor(RGB(rand()%256,rand()%256,rand()%256));
			GDIInput->dcGDI->TextOut(rand()% GDIInput->Width,rand() % GDIInput->Height,cstr);
			count++;
		}
		GDIInput->dcGDI->SelectObject(oldFont);
		GDIInput->dcGDI->SetBkMode(OPAQUE);
	}else if(GDIInput->Option == 3){
		myFont.CreatePointFont(320,"lr oSVbN",NULL);
		CFont* oldFont = GDIInput->dcGDI->SelectObject(&myFont);
//		GDIInput->dcGDI->SetBkMode(TRANSPARENT);
		for(;FlagLoop;){
			int X = rand() % GDIInput->Width;
			int Y = rand() % GDIInput->Height;
			GDIInput->dcGDI->SetTextColor(RGB(rand()%256,rand()%256,rand()%256));
			for(int i=0;i<6;i++){
				GDIInput->dcGDI->TextOut(X++,Y++,cstr);
				count++;
			}
		}
		GDIInput->dcGDI->SelectObject(oldFont);
//		GDIInput->dcGDI->SetBkMode(OPAQUE);
	}else if(GDIInput->Option == 4){
		myFont.CreatePointFont(320,"lr oSVbN",NULL);
		CFont* oldFont = GDIInput->dcGDI->SelectObject(&myFont);
		GDIInput->dcGDI->SetBkMode(TRANSPARENT);
		for(;FlagLoop;){
			int X = rand() % GDIInput->Width;
			int Y = rand() % GDIInput->Height;
			int R = rand() % 128 + 128;
			int G = rand() % 128 + 128;
			int B = rand() % 128 + 128;
			for(int i=0;i<4;i++){
				GDIInput->dcGDI->SetTextColor(RGB(R-=8,G-=8,B-=8));
				GDIInput->dcGDI->TextOut(X++,Y++,cstr);
				count++;
			}
		}
		GDIInput->dcGDI->SelectObject(oldFont);
		GDIInput->dcGDI->SetBkMode(OPAQUE);
	}
	ThreadStruct->result = count;
}

void GDISquareThread(void *thread)
{
	int RectSize = 64;
	_ThreadStruct* ThreadStruct = (_ThreadStruct *)thread;
	_GDIInput* GDIInput = (_GDIInput*)(ThreadStruct->ExData);
	DWORD count = 0;

	CBrush myBrush,*pOldBrush;
	CPen myPen,*pOldPen;
	CRect rect;
	DWORD WidthLimit = GDIInput->Width - RectSize + 1;
	DWORD HeightLimit = GDIInput->Height - RectSize + 1;
	if(GDIInput->Option == 1){
		pOldBrush = (CBrush*)GDIInput->dcGDI->SelectStockObject(NULL_BRUSH);
		for(;FlagLoop;){
			rect.left  = rand() % WidthLimit;rect.right = rect.left + RectSize;
			rect.top   = rand() % HeightLimit;rect.bottom= rect.top + RectSize;
			myPen.CreatePen(PS_SOLID,1,RGB(rand()%256,rand()%256,rand()%256));
			pOldPen = GDIInput->dcGDI->SelectObject(&myPen);
			GDIInput->dcGDI->Rectangle(&rect);
			GDIInput->dcGDI->SelectObject(pOldPen);
			myPen.DeleteObject();
			count++;
		}
		GDIInput->dcGDI->SelectObject(pOldBrush);
		myBrush.DeleteObject();
	}else if(GDIInput->Option == 2){
		myPen.CreatePen(PS_SOLID,1,RGB(0,0,0));
		pOldPen = GDIInput->dcGDI->SelectObject(&myPen);
		for(;FlagLoop;){
			rect.left  = rand() % WidthLimit;rect.right = rect.left + RectSize;
			rect.top   = rand() % HeightLimit;rect.bottom= rect.top + RectSize;
			myBrush.CreateSolidBrush(RGB(rand()%256,rand()%256,rand()%256));
			pOldBrush = GDIInput->dcGDI->SelectObject(&myBrush);
			GDIInput->dcGDI->Rectangle(&rect);
			GDIInput->dcGDI->SelectObject(pOldBrush);
			myBrush.DeleteObject();
			count++;
		}
		GDIInput->dcGDI->SelectObject(pOldPen);
		myPen.DeleteObject();	
	}else if(GDIInput->Option == 3){
		myPen.CreatePen(PS_SOLID,1,RGB(rand()%256,rand()%256,rand()%256));
		pOldPen = GDIInput->dcGDI->SelectObject(&myPen);
		for(;FlagLoop;){
			rect.left  = rand() % WidthLimit;rect.right = rect.left + RectSize;
			rect.top   = rand() % HeightLimit;rect.bottom= rect.top + RectSize;
			myBrush.CreateHatchBrush(HS_CROSS,RGB(rand()%256,rand()%256,rand()%256));
			pOldBrush = GDIInput->dcGDI->SelectObject(&myBrush);
			GDIInput->dcGDI->Rectangle(&rect);
			GDIInput->dcGDI->SelectObject(pOldBrush);
			myBrush.DeleteObject();
			count++;
		}
	}else if(GDIInput->Option == 4){
		RectSize = 128;
		WidthLimit = GDIInput->Width - RectSize + 1;
		HeightLimit = GDIInput->Height - RectSize + 1;
		pOldBrush = (CBrush*)GDIInput->dcGDI->SelectStockObject(NULL_BRUSH);
		for(;FlagLoop;){
			rect.left  = rand() % WidthLimit;rect.right = rect.left + RectSize;
			rect.top   = rand() % HeightLimit;rect.bottom= rect.top + RectSize;
			int R = rand() % 128 + 128;
			int G = rand() % 128 + 128;
			int B = rand() % 128 + 128;
			for(int i=1;i<64;i++){
				rect.left++;rect.top++;rect.right--;rect.bottom--;
				myPen.CreatePen(PS_SOLID,1,RGB(R--,G--,B--));
				pOldPen = GDIInput->dcGDI->SelectObject(&myPen);
				GDIInput->dcGDI->Rectangle(&rect);
				GDIInput->dcGDI->SelectObject(pOldPen);
				myPen.DeleteObject();
				count++;
			}
		}
		GDIInput->dcGDI->SelectObject(pOldBrush);
		myBrush.DeleteObject();
	}
	ThreadStruct->result = count;
}

void GDICircleThread(void *thread)
{
	_ThreadStruct* ThreadStruct = (_ThreadStruct *)thread;
	_GDIInput* GDIInput = (_GDIInput*)(ThreadStruct->ExData);
	int CircleSize = 64;

	DWORD count = 0;

	CBrush myBrush,*pOldBrush;
	CPen myPen,*pOldPen;
	CRect rect;
	DWORD WidthLimit = GDIInput->Width - CircleSize + 1;
	DWORD HeightLimit = GDIInput->Height - CircleSize + 1;

	GDIInput->dcGDI->SetBkColor(RGB(255,255,255));
	if(GDIInput->Option == 1){
		pOldBrush = (CBrush*)GDIInput->dcGDI->SelectStockObject(NULL_BRUSH);
		for(;FlagLoop;){
			rect.left  = rand() % WidthLimit;rect.right = rect.left + CircleSize;
			rect.top   = rand() % HeightLimit;rect.bottom= rect.top + CircleSize;
			myPen.CreatePen(PS_SOLID,1,RGB(rand()%256,rand()%256,rand()%256));
			pOldPen = GDIInput->dcGDI->SelectObject(&myPen);
			GDIInput->dcGDI->Ellipse(&rect);
			GDIInput->dcGDI->SelectObject(pOldPen);
			myPen.DeleteObject();
			count++;
		}
		GDIInput->dcGDI->SelectObject(pOldBrush);
		myBrush.DeleteObject();
	}else if(GDIInput->Option == 2){
		myPen.CreatePen(PS_SOLID,1,RGB(0,0,0));
		pOldPen = GDIInput->dcGDI->SelectObject(&myPen);
		for(;FlagLoop;){
			rect.left  = rand() % WidthLimit;rect.right = rect.left + CircleSize;
			rect.top   = rand() % HeightLimit;rect.bottom= rect.top + CircleSize;
			myBrush.CreateSolidBrush(RGB(rand()%256,rand()%256,rand()%256));
			pOldBrush = GDIInput->dcGDI->SelectObject(&myBrush);
			GDIInput->dcGDI->Ellipse(&rect);
			GDIInput->dcGDI->SelectObject(pOldBrush);
			myBrush.DeleteObject();
			count++;
		}
		GDIInput->dcGDI->SelectObject(pOldPen);
		myPen.DeleteObject();	
	}else if(GDIInput->Option == 3){
		myPen.CreatePen(PS_SOLID,1,RGB(rand()%256,rand()%256,rand()%256));
		pOldPen = GDIInput->dcGDI->SelectObject(&myPen);
		for(;FlagLoop;){
			rect.left  = rand() % WidthLimit;rect.right = rect.left + CircleSize;
			rect.top   = rand() % HeightLimit;rect.bottom= rect.top + CircleSize;
			myBrush.CreateHatchBrush(HS_CROSS,RGB(rand()%256,rand()%256,rand()%256));
			pOldBrush = GDIInput->dcGDI->SelectObject(&myBrush);
			GDIInput->dcGDI->Ellipse(&rect);
			GDIInput->dcGDI->SelectObject(pOldBrush);
			myBrush.DeleteObject();
			count++;
		}
		GDIInput->dcGDI->SelectObject(pOldPen);
		myPen.DeleteObject();
	}else if(GDIInput->Option == 4){
		CircleSize = 128;
		WidthLimit = GDIInput->Width - CircleSize + 1;
		HeightLimit = GDIInput->Height - CircleSize + 1;
		pOldBrush = (CBrush*)GDIInput->dcGDI->SelectStockObject(NULL_BRUSH);
		for(;FlagLoop;){
			rect.left  = rand() % WidthLimit;rect.right = rect.left + CircleSize;
			rect.top   = rand() % HeightLimit;rect.bottom= rect.top + CircleSize;
			int R = rand() % 128 + 128;
			int G = rand() % 128 + 128;
			int B = rand() % 128 + 128;
			for(int i=1;i<64;i++){
				rect.left++;rect.top++;rect.right--;rect.bottom--;
				myPen.CreatePen(PS_SOLID,2,RGB(R--,G--,B--));
				pOldPen = GDIInput->dcGDI->SelectObject(&myPen);
				GDIInput->dcGDI->Ellipse(&rect);
				GDIInput->dcGDI->SelectObject(pOldPen);
				myPen.DeleteObject();
				count++;
			}
		}
		GDIInput->dcGDI->SelectObject(pOldBrush);
		myBrush.DeleteObject();
	}
	ThreadStruct->result = count;
}

void GDIBitBltThread(void *thread)
{
	_ThreadStruct* ThreadStruct = (_ThreadStruct *)thread;
	_GDIInput* GDIInput = (_GDIInput*)(ThreadStruct->ExData);
	DWORD count = 0;

	CBitmap Bitmap,*pOldBitmap;
	CDC Memory;
	BITMAP bmp;

	Bitmap.LoadBitmap(IDB_BITMAP);
	Memory.CreateCompatibleDC(GDIInput->dcGDI); 
	pOldBitmap = (CBitmap*)Memory.SelectObject(&Bitmap);
	Bitmap.GetObject(sizeof(bmp),&bmp);
	DWORD Width = bmp.bmWidth;
	DWORD Height= bmp.bmHeight;

	if(GDIInput->Option == 1){
		for(;FlagLoop;){
			GDIInput->dcGDI->BitBlt(rand() % (GDIInput->Width - Width + 1 ) ,rand() % (GDIInput->Height - Height +1 ) ,Width,Height,&Memory, 0,0, SRCCOPY);
			count++;
		}
	}else if(GDIInput->Option == 2){
		DWORD Width2 = Width / 2;
		DWORD Height2= Height/ 2;
		for(;FlagLoop;){
			GDIInput->dcGDI->StretchBlt(rand() % (GDIInput->Width - Width2 + 1 ) ,rand() % (GDIInput->Height - Height2 +1 ),Width2,Height2,&Memory, 0,0,Width,Height,SRCCOPY);
			count++;
		}
	}else if(GDIInput->Option == 3){
		DWORD Width2 = Width * 2;
		DWORD Height2= Height* 2;
		for(;FlagLoop;){
			GDIInput->dcGDI->StretchBlt(rand() % (GDIInput->Width - Width2 + 1 ) ,rand() % (GDIInput->Height - Height2 +1 ),Width2,Height2,&Memory, 0,0,Width,Height,SRCCOPY);
			count++;
		}
	}else if(GDIInput->Option == 4){
		// AlphaBlend //
		typedef int (WINAPI *Alpha) (HDC,int,int,int,int,HDC,int,int,int,int,BLENDFUNCTION);
		HINSTANCE hLib = LoadLibrary("msimg32.dll");
		Alpha pAlpha = (Alpha) GetProcAddress (hLib,"AlphaBlend");

		BLENDFUNCTION alpha;
		alpha.BlendFlags = 0;
		alpha.BlendOp = AC_SRC_OVER;
		alpha.AlphaFormat = 0;

		for(;FlagLoop;){
			alpha.SourceConstantAlpha = rand()%256;
			pAlpha(GDIInput->dcGDI->m_hDC,rand() % (GDIInput->Width - Width + 1 ) ,rand() % (GDIInput->Height - Height +1 ),Width,Height,Memory.m_hDC, 0,0,Width,Height, alpha);
			count++;
		}

		FreeLibrary(hLib);
	}
	Memory.SelectObject(pOldBitmap);
	Memory.DeleteDC();

	ThreadStruct->result = count;
}